%{!?upstream_version: %global upstream_version %{version}}
%global upstream_name tripleo-common

%{?!_licensedir:%global license %%doc}

Name:           openstack-tripleo-common
Summary:        Python library for code used by TripleO projects.
Version:        8.6.1
Release:        23%{?dist}
License:        ASL 2.0
URL:            https://github.com/rdo-management/tripleo-common

Source0:        https://tarballs.openstack.org/%{upstream_name}/%{upstream_name}-%{version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=8.6.1
Patch0001: 0001-DOWNSTREAM-ONLY-Set-container-image-names-for-downst.patch
Patch0002: 0002-DOWNSTREAM-ONLY-Remove-qdrouterd-containers.patch
Patch0003: 0003-DOWNSTREAM-ONLY-Remove-skydive-novajoin-and-congress.patch
Patch0004: 0004-DOWNSTREAM-ONLY-Remove-rsyslog-container-image.patch
Patch0005: 0005-DOWNSTREAM-ONLY-container-build-overrides.patch
Patch0006: 0006-DOWNSTREAM-ONLY-Remove-keepalived-container.patch
Patch0007: 0007-DOWNSTREAM-ONLY-exclude-neutron-vpn-agent-for-l3-con.patch
Patch0008: 0008-Fix-parameter-indentation-on-Swift-rebalance-playboo.patch
Patch0009: 0009-Fix-error-handling-in-set_provision_state-set_power_.patch
Patch0010: 0010-Only-update-plan-on-upgrade-converge.patch
Patch0011: 0011-Use-ansible_queue_name-only-for-upgrade-update.patch
Patch0012: 0012-Fix-healthcheck-script-for-neutron-api-service.patch
Patch0013: 0013-Add-in-a-STOPSIGNAL-configuration.patch
Patch0014: 0014-Fix-tarball-generation-when-downloading-logs.patch
Patch0015: 0015-DOWNSTREAM-ONLY-Fix-unit-tests-for-kolla-builder.patch
Patch0016: 0016-Don-t-set-deployments-as-hostvars.patch
Patch0017: 0017-Allow-uploading-big-files-to-swift-5GB.patch
Patch0018: 0018-Create-keypair-for-SSH-access-to-Octavia-amphorae.patch
Patch0019: 0019-Octavia-amphora-image-handles-updates-and-symlinks.patch
Patch0020: 0020-Find-deployment-name-in-config-download.patch
Patch0021: 0021-Fix-missing-docker-package-in-neutron-L3-agent-conta.patch
Patch0022: 0022-Check-pub-key-file-perms-and-default-to-pub-key-data.patch
Patch0023: 0023-Install-Octavia-amphora-image-if-Red-Hat.patch
Patch0024: 0024-Add-a-trash_output-flag-to-ansible-playbook-action.patch
Patch0025: 0025-Persist-package-update-ansible-logs.patch
Patch0026: 0026-Add-special-all-for-deploy_on_servers-server-name-to.patch
Patch0027: 0027-Increase-services-project-quotas-when-deploying-Octa.patch
Patch0028: 0028-DOWNSTREAM-ONLY-Force-include-docker.yaml-and-docker.patch
Patch0029: 0029-Fix-Octavia-amphora-image-RPM-install.patch
Patch0030: 0030-Make-lb-mgmt-subnet-a-class-B-subnet.patch
Patch0031: 0031-Increase-services-project-secgroup-rules-quotas-when.patch
Patch0032: 0032-Get-deployment_stack_id-via-deployment_ref-for-confi.patch
Patch0033: 0033-Pass-container-and-queue_name-inputs-to-the-list_ava.patch
Patch0034: 0034-Include-xattrs-when-creating-the-undercloud-backup.patch
Patch0035: 0035-Let-TripleO-generate-ODLPassword.patch
Patch0036: 0036-Provide-timestamps-in-Ansible-output-by-default.patch

BuildArch:      noarch
BuildRequires:  git
BuildRequires:  python2-setuptools
BuildRequires:  python2-devel
BuildRequires:  python2-pbr
BuildRequires:  openstack-macros

Requires: GitPython
Requires: python2-jinja2
Requires: python2-glanceclient >= 1:2.8.0
Requires: python2-heatclient >= 1.10.0
Requires: python-ironic-inspector-client >= 1.5.0
Requires: python2-ironicclient >= 2.2.0
Requires: python2-keystoneclient
Requires: python2-novaclient >= 1:9.1.0
Requires: python2-mistral-lib >= 0.3.0
Requires: python2-mistralclient >= 3.1.0
Requires: python2-netaddr
Requires: python-netifaces
Requires: python2-oslo-concurrency >= 3.25.0
Requires: python2-oslo-config >= 2:5.1.0
Requires: python2-oslo-log >= 3.36.0
Requires: python2-oslo-utils >= 3.33.0
Requires: python2-six >= 1.10.0
Requires: python2-docker >= 2.4.2
Requires: python2-passlib
Requires: python2-keystoneauth1 >= 3.3.0
Requires: python2-pbr >= 2.0.0
Requires: python2-zaqarclient >= 1.0.0
Requires: %{name}-containers = %{version}-%{release}
Requires: python-paramiko
Requires: skopeo
Requires: ansible
Requires: python2-tenacity >= 3.2.1

Provides:  tripleo-common = %{version}-%{release}
Obsoletes: tripleo-common < %{version}-%{release}

%prep
%autosetup -n %{upstream_name}-%{upstream_version} -S git
rm -rf *.egg-info

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup

%build
%{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root=%{buildroot}
if [ -d %{buildroot}/%{_datadir}/%{upstream_name} ]; then
  mv %{buildroot}/%{_datadir}/%{upstream_name} %{buildroot}/%{_datadir}/%{name}
else
  # Before https://review.openstack.org/#/c/327830/3/setup.cfg
  mkdir -p %{buildroot}/%{_datadir}/%{name}
  if [ -d image-yaml ]; then
    install -d -m 755 %{buildroot}/%{_datadir}/%{name}
    cp -ar image-yaml %{buildroot}/%{_datadir}/%{name}
  fi
fi
ln -s %{name} %{buildroot}%{_datadir}/%{upstream_name}

if [ -d workbooks ]; then
  cp -ar workbooks %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/workbooks
fi

if [ -d playbooks ]; then
  cp -ar playbooks %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/playbooks
fi

if [ -d healthcheck ]; then
  cp -ar healthcheck %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/healthcheck
fi

if [ ! -d roles ]; then
  mkdir -p %{buildroot}/%{_datadir}/ansible/roles
fi

mkdir -p %{buildroot}/%{_datadir}/%{name}-containers
mv %{buildroot}/%{_datadir}/%{name}/container-images %{buildroot}/%{_datadir}/%{name}-containers/
# compat symlink
ln -s ../%{name}-containers/container-images  %{buildroot}/%{_datadir}/%{name}/

if [ -d heat_docker_agent ]; then
  cp -ar heat_docker_agent %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/heat_docker_agent
fi

install -p -D -m 440 sudoers %{buildroot}%{_sysconfdir}/sudoers.d/%{upstream_name}

%description
Python library for code used by TripleO projects.

%package containers
Summary: Files for building TripleO containers

%description containers
This package installs the files used to build containers for TripleO.

%package container-base
Summary: Package for the TripleO base container image
Requires: puppet
Requires: lsof
Requires: hostname

%description container-base
This package installs the dependencies and files which are required on the base
TripleO container image.

%package devtools
Summary: A collection of tools for TripleO developers and CI
Requires: %{name} = %{version}-%{release}

%description devtools
This package installs the TripleO tools for developers and CI that typically
don't fit in a product.

%files
%license LICENSE
%doc README.rst AUTHORS ChangeLog
%{python2_sitelib}/tripleo_common*
%exclude %{python2_sitelib}/tripleo_common/test*
%{_prefix}/lib/heat/undercloud_heat_plugins
%{_bindir}/upgrade-non-controller.sh
%{_bindir}/tripleo-build-images
%{_bindir}/upload-puppet-modules
%{_bindir}/upload-swift-artifacts
%{_bindir}/run-validation
%{_bindir}/tripleo-config-download
%{_bindir}/create_freeipa_enroll_envfile.py
%{_datadir}/%{name}
%{_datadir}/%{upstream_name}
%{_sysconfdir}/sudoers.d/%{upstream_name}
%{_datadir}/ansible/roles

%files containers
%{_datadir}/%{name}-containers/container-images

%files container-base
%{_bindir}/bootstrap_host_exec
%{_bindir}/bootstrap_host_only_eval
%{_bindir}/bootstrap_host_only_exec
%{_datadir}/%{name}/healthcheck

%files devtools
%{_bindir}/pull-puppet-modules

%changelog
* Tue Jul 03 2018 Carlos Camacho <ccamacho@redhat.com> 8.6.1-23
- Provide timestamps in Ansible output by default (rhbz#1592823)

* Fri Jun 29 2018 Tim Rozet <trozet@redhat.com> 8.6.1-22
- Let TripleO generate ODLPassword (rhbz#1594328)

* Wed Jun 27 2018 Carlos Camacho <ccamacho@redhat.com> 8.6.1-21
- Include --xattrs when creating the undercloud backup. (rhbz#1594279)

* Mon Jun 11 2018 “Beth <belwell@redhat.com> 8.6.1-20
- Pass container and queue_name inputs to the list_available_roles workflow (rhbz#1588838)

* Tue Jun 05 2018 Carlos Camacho <ccamacho@redhat.com> 8.6.1-19
- Get deployment_stack_id via deployment_ref for config download (rhbz#1584951)

* Mon May 28 2018 Nir Magnezi <nmagnezi@redhat.com> 8.6.1-18
- Increase services project secgroup-rules quotas when deploying Octavia (rhbz#1560422)

* Thu May 24 2018 Nir Magnezi <nmagnezi@redhat.com> 8.6.1-17
- Make lb-mgmt-subnet a class B subnet (rhbz#1577612)

* Thu May 24 2018 Nir Magnezi <nmagnezi@redhat.com> 8.6.1-16
- Fix Octavia amphora image RPM install (rhbz#1414022)

* Thu May 24 2018 Sergii Golovatiuk <sgolovat@redhat.com> 8.6.1-15
- [DOWNSTREAM ONLY] Force include docker.yaml and docker-ha.yaml (rhbz#1576343)

* Fri May 18 2018 Mathieu Bultel <mbultel@redhat.com> 8.6.1-14
- Increase services project quotas when deploying Octavia (rhbz#1560422)
- Add special 'all' for deploy_on_servers server name to match all (rhbz#1561255)
- Persist package update ansible logs (rhbz#1572827)

* Fri May 18 2018 Carlos Goncalves <cgoncalves@redhat.com> 8.6.1-13
- Increase services project quotas when deploying Octavia (rhbz#1560422)

* Wed May 16 2018 Nir Magnezi <nmagnezi@redhat.com> 8.6.1-12
- Install Octavia amphora image if Red Hat (rhbz#1414022)

* Tue May 15 2018 Carlos Goncalves <cgoncalves@redhat.com> 8.6.1-11
- Check pub key file perms and default to pub key data (rhbz#1561935)

* Mon May 14 2018 Brent Eagles <beagles@redhat.com> 8.6.1-10
- Fix missing docker package in neutron L3 agent container (rhbz#1527130)

* Wed May 09 2018 Jose Luis Franco Arza <jfrancoa@redhat.com> 8.6.1-9
- Find deployment name in config download (rhbz#1565374)

* Wed May 09 2018 Carlos Goncalves <cgoncalves@redhat.com> 8.6.1-8
- Octavia amphora image handles updates and symlinks (rhbz#1414022)

* Mon May 07 2018 Carlos Goncalves <cgoncalves@redhat.com> 8.6.1-7
- Create keypair for SSH access to Octavia amphorae (rhbz#1561935)

* Tue May 01 2018 Alex Schultz <aschultz@redhat.com> 8.6.1-6
- Allow uploading big files to swift (5GB) (rhbz#1563783)
- Fix tarball generation when downloading logs (rhbz#1568743)
- Add in a STOPSIGNAL configuration (rhbz#1566463)

* Thu Apr 26 2018 Bernard Cafarelli <bcafarel@redhat.com> 8.6.1-5
- Fix healthcheck script for neutron-api service (rhbz#1563253)

* Wed Apr 25 2018 Jon Schlueter <jschluet@redhat.com> 8.6.1-4
- Use ansible_queue_name only for upgrade/update (rhbz#1568714)
- Only update plan on upgrade converge
- Fix error handling in set_provision_state/set_power_state workflows (rhbz#1536521 rhbz#1435591)

* Tue Apr 24 2018 Jon Schlueter <jschluet@redhat.com> 8.6.1-3
- Fix parameter indentation on Swift rebalance playbook (rhbz#1469435)

* Tue Apr 24 2018 Jon Schlueter <jschluet@redhat.com> 8.6.1-2
- [DOWNSTREAM ONLY] exclude neutron-vpn-agent for l3-container (rhbz#1567142)
- [DOWNSTREAM ONLY] Remove keepalived container
- [DOWNSTREAM ONLY] container build overrides
- [DOWNSTREAM ONLY] Remove rsyslog container image
- [DOWNSTREAM ONLY] Remove skydive, novajoin and congress-api from overcloud_containers (rhbz#1535610)
- [DOWNSTREAM ONLY] Remove qdrouterd containers (rhbz#1500528 rhbz#1500531 rhbz#1535610)
- [DOWNSTREAM ONLY] Set container image names for downstream (rhbz#1509324)

* Mon Apr 23 2018 RDO <dev@lists.rdoproject.org> 8.6.1-1
- Update to 8.6.1

* Tue Mar 27 2018 Jon Schlueter <jschluet@redhat.com> 8.6.0-1
- Update to 8.6.0

* Thu Mar 08 2018 RDO <dev@lists.rdoproject.org> 8.5.0-1
- Update to 8.5.0

